			      ;CICLOIDE - Umberto Barone
;;;Questo lisp  stato realizzato da Umberto Barone;
;;; gratis e vieto a chiunque di utilizzarlo a fini di lucro,
;;;pu essere liberamente utilizzato, modificato, distribuito;
;;;prego solo di lasciare questa firma come riconoscimento dei diritti 
;;;intelettuali e delle ore perse
;;;;name: cicloide.lsp
;;;command: cicloide
;;;input: tipo centro raggio1 raggio2 (raggio g)
;;;output: draw
;;;
;;;i file cicloide.dcl e guidacicl.html e la Dir "guidacicl_file" vanno collocati nella directory Support di acad
;;;
;;;umberb@infinito.it
;;;htpp://web.tiscalinet.it/umberweb

 ;______________________________SETTAGGIO VARIABILI________________________________________

(defun set_var ()
  (setq	snap (getvar "osmode")
	cmd  (getvar "cmdecho")
	)
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)
  (princ)
  )

 ;______________________________RISETTAGGIO VARIABILI________________________________________

(defun reset_var ()	      ;snap cmd
  (setvar "osmode" snap)
  (setvar "cmdecho" cmd)
  (princ)
  )

 ;_______________________________info dialog_______________________________________
(defun info (/ dcl_id1)
  (setq dcl_id1 (load_dialog "cicloide.dcl")) ;carica DCL
  (if (not (new_dialog "info" dcl_id1))
    (exit)
    )
  (action_tile "accept" "(done_dialog)")
  (start_dialog)
  (unload_dialog dcl_id1)
  (princ)
  )			      ;end defun

 ;____________________________MAIN PROGRAM__________________________________________
(defun c:cicloide (/ dcl_id dcl_id1 xc yc comand center select p2	fir
		   fir*	lista_p	con cicloide epicicl ipocicl cicloidea
		   epitroc ipotroc nvett360 lambd_a 
		   )
  (setq temperr *error*)      ;salva *error*
  (setq *error* trappola)     ;ridefinisci *error*
  (setq comand 2)
  (while (> comand 1) 
  (if (findfile "cicloide.dcl")
    (progn
      (setq dcl_id (load_dialog "cicloide.dcl")) ;carica DCL
      (if (not (new_dialog "cicloide" dcl_id))
	(exit)
	)
      (mode_tile "eb_b" 1)
      (mode_tile "eb_rg" 1)
      (setq cicloide "1")
      (action_tile
	"accept"
	(strcat
	  "(progn (setq a(atof (get_tile \"eb_a\")))"
	  "(setq nvett360 (atof (get_tile \"nvett360\")))"
	  "(cond ((or (= epicicl \"1\")(= ipocicl \"1\"))"
	  "(setq b(atof (get_tile \"eb_b\"))))"
	  "((= cicloidea \"1\")(setq rg(atof (get_tile \"eb_rg\"))))"
	  "((or (= epitroc \"1\")(= ipotroc \"1\"))"
	  "(setq b(atof (get_tile \"eb_b\")))"
	  "(setq rg(atof (get_tile \"eb_rg\")))))"
	  "(cond ((= select \"0\")"
	  "(setq xc (atof(get_tile \"eb_xc\")))"
	  "(setq yc  (atof(get_tile \"eb_yc\")))))" "(done_dialog 1))"
	  )
	)		      ;OK action
      (action_tile "cancel" "(done_dialog 0)") ;cancel action
      (action_tile
	"select"
	"(setq select $value)(update1)" ;toggle select	\\\
	)
      (action_tile "info" "(info)") ;info action
      (action_tile "guida" "(done_dialog 2)") ;guida
      (action_tile
	"rb_cicloide"
	"(setq cicloide $value)(setq cicloidea 0 epicicl 0 ipocicl 0 epitroc 0 ipotroc 0)(enable_brg)"
	)
      (action_tile
	"rb_epicicl"
	"(setq epicicl $value)(setq cicloidea 0 cicloide 0 ipocicl 0 epitroc 0 ipotroc 0)(enable_brg)"
	)
      (action_tile
	"rb_ipocicl"
	"(setq ipocicl $value)(setq cicloidea 0 epicicl 0 cicloide 0 epitroc 0 ipotroc 0)(enable_brg)"
	)
      (action_tile
	"rb_cicloidea"
	"(setq cicloidea $value)(setq cicloide 0 epicicl 0 ipocicl 0 epitroc 0 ipotroc 0)(enable_brg)"
	)
      (action_tile
	"rb_epitroc"
	"(setq epitroc $value)(setq cicloidea 0 epicicl 0 ipocicl 0 cicloide 0 ipotroc 0)(enable_brg)"
	)
      (action_tile
	"rb_ipotroc"
	"(setq ipotroc $value)(setq cicloidea 0 epicicl 0 ipocicl 0 epitroc 0 cicloide 0)(enable_brg)"
	)
      (action_tile
	"nvett360slide"	      ;*if user moves slider
	"(slide1 $value $reason)"
	)		      ;*pass arguments to slider_action
      (action_tile
	"nvett360"	      ;*is user enters slot length
	"(ebox1 $value $reason)"
	)		      ;*pass arguments to ebox_action
      (defun slide1 (val why) ;*define function
	(if (or (= why 2) (= why 1)) ;*check values
	  (set_tile "nvett360" val)
	  )
	)		      ;*update edit box
      (defun ebox1 (val why)  ;*define function
	(if (or (= why 2) (= why 1)) ;*check values
	  (set_tile "nvett360slide" val)
	  )
	)
      (setq comand (start_dialog))
      (unload_dialog dcl_id)
      (cond
	((= comand 1)	      ;OK action
	 (cond ((= select "0") (setq center (list xc yc)))
	       ((= select "1")
		(setq center (getpoint "\nSeleziona  centro: "))
		)
	       )
	 (set_var)
	 (command "_.ucs" "_n" center)
	 (setq fir     0
	       fir*    (gradrad (/ 360 nvett360)) ;precisione
	       con     t
	       lista_p nil
	       )	      ;se non ordinaria calcola lambda(o =rg), altrimenti 1 o b
	 (cond
	   ((or (= cicloidea "1")) (setq lambd_a (/ rg a)))
	   ((or (= epicicl "1") (= ipocicl "1")) (setq lambd_a b))
	   ((or (= epitroc "1") (= ipotroc "1")) (setq lambd_a rg))
	   ((= cicloide "1") (setq lambd_a 1.0))
	   )		      ;CICLOIDE & cicloidea
	 (cond ((or (= cicloide "1") (= cicloidea "1"))
		(while con
		  (setq	X  (* a (- fir (* lambd_a (sin fir))))
			Y  (* a (- 1 (* lambd_a (cos fir))))
			p2 (list X Y)
			)
		  (setq	fir	(+ fir fir*)
			lista_p	(cons p2 lista_p)
			)
		  (if (>= fir (* 2.0 pi))
		    (setq con nil)
		    )
		  )
		)	      ;EPICICLOIDE & EPITROCOIDE
	       ((or (= epicicl "1") (= epitroc "1"))
		(while con
		  (setq	c  (/ (+ a b) b) ;cost
			X  (- (* (+ a b) (cos fir))
			      (* lambd_a (cos (* c fir)))
			      )
			Y  (- (* (+ a b) (sin fir))
			      (* lambd_a (sin (* c fir)))
			      )
			p2 (list X Y)
			)
		  (setq	fir	(+ fir fir*)
			lista_p	(cons p2 lista_p)
			)
		  (if (>= fir (* 2.0 pi))
		    (setq con nil)
		    )
		  )
		)	      ;IPOCICLOIDE & IPOTROCOIDE
	       ((or (= ipocicl "1") (= ipotroc "1"))
		(while con
		  (setq	c  (/ (- a b) b) ;cost
			X  (+ (* (- a b) (cos fir))
			      (* lambd_a (cos (* c fir)))
			      )
			Y  (- (* (- a b) (sin fir))
			      (* lambd_a (sin (* c fir)))
			      )
			p2 (list X Y)
			)
		  (setq	fir	(+ fir fir*)
			lista_p	(cons p2 lista_p)
			)
		  (if (>= fir (* 2.0 pi))
		    (setq con nil)
		    )
		  )
		)
	       )
	 (setq lista_p (reverse lista_p))
	 ;;inverti la lista
	 (command "_.pline" (foreach p lista_p (command p)))
	 ;;disegno
	 (command "_.ucs" "_p")
	 (reset_var)
	 )
	((= comand 2)
	 (command "_.browser" (findfile "guidacicl.html"))
	 )
	)		      ;progn
      )			      ;if
    )	)		      ;fine while
			      ;end if,progn of findfile
  (princ)
  )			      ;fine defun c:
 ;______________________________________________________________________
(prompt " Digita  cicloide  per eseguire")

 ;__________________________________UPDATE1____________________________________
(defun update1 ()
  (cond	((= select "0")
	 (mode_tile "eb_xc" 0)
	 (mode_tile "eb_yc" 0)
	 (mode_tile "eb_zc" 0)
	 )
	((= select "1")
	 (mode_tile "eb_xc" 1)
	 (mode_tile "eb_yc" 1)
	 (mode_tile "eb_zc" 1)
	 )
	)		      ;end cond
  )
			      ;:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;ENABLE_BRG_________________________
(defun enable_brg ()
  (cond	((= cicloide "1")
	 (mode_tile "eb_b" 1)
	 (mode_tile "eb_rg" 1)
	 )
	((or (= epicicl "1") (= ipocicl "1"))
	 (mode_tile "eb_b" 0)
	 (mode_tile "eb_rg" 1)
	 )
	((= cicloidea "1")
	 (mode_tile "eb_b" 1)
	 (mode_tile "eb_rg" 0)
	 )
	((or (= epitroc "1") (= ipotroc "1"))
	 (mode_tile "eb_b" 0)
	 (mode_tile "eb_rg" 0)
	 )
	)
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;TRAPPOLA__________________________________________--

(defun trappola	(errmsg)
  (reset_var)
  (setq *error* temperr)      ;restore *error*
  (prompt "\nResetting System Variables ") ;inform user
  (princ)
  )

(defun gradrad (alfa) (/ (* alfa pi) 180.0))

